﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace howto_font_metrics
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ResizeRedraw = true;
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            e.Graphics.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAliasGridFit;

            string txt = "Mgfi";
            RectangleF layout_rect = new RectangleF(0, 0,
                this.ClientSize.Width / 3, this.ClientSize.Height);
            using (StringFormat string_format = new StringFormat())
            {
                string_format.LineAlignment = StringAlignment.Center;
                string_format.Alignment = StringAlignment.Center;

                // using (the_font As New Font("Times New Roman", 240, FontStyle.Bold, GraphicsUnit.Document)
                // using (the_font As New Font("Times New Roman", 0.8, FontStyle.Bold, GraphicsUnit.Inch)
                // using (the_font As New Font("Times New Roman", 60, FontStyle.Bold, GraphicsUnit.Point)
                // using (the_font As New Font("Times New Roman", 80, FontStyle.Bold, GraphicsUnit.Pixel)
                //using (the_font As New Font("Times New Roman", 22, FontStyle.Bold, GraphicsUnit.Millimeter)
                using (Font the_font = new Font("Times New Roman", 80, FontStyle.Bold, GraphicsUnit.Pixel))
                {
                    MeasureCharacters(e.Graphics, the_font, txt, layout_rect, string_format);
                }

                layout_rect.X += this.ClientSize.Width / 3;
                using (Font the_font = new Font("Comic Sans MS", 80, FontStyle.Bold, GraphicsUnit.Pixel))
                {
                    MeasureCharacters(e.Graphics, the_font, txt, layout_rect, string_format);
                }

                layout_rect.X += this.ClientSize.Width / 3;
                using (Font the_font = new Font("Courier New", 80, FontStyle.Bold, GraphicsUnit.Pixel))
                {
                    MeasureCharacters(e.Graphics, the_font, txt, layout_rect, string_format);
                }
            }
        }

        // Draw the string's metrics.
        public void MeasureCharacters(Graphics gr, Font the_font, string txt, RectangleF layout_rect , StringFormat string_format )
        {
            // Define an array of CharacterRange objects, 
            // one for each character.
            CharacterRange[] character_ranges = new CharacterRange[txt.Length];
            for (int i = 0; i <  txt.Length ; i++)
            {
                character_ranges[i] = new CharacterRange(i, 1);
            }

            // Set the ranges in the StringFormat object.
            string_format.SetMeasurableCharacterRanges(character_ranges);

            // Get the character range regions.
            Region[] character_regions = gr.MeasureCharacterRanges(
                txt, the_font, layout_rect, string_format);

            // Get the font's metrics.
            FontInfo font_info = new FontInfo(gr, the_font);

            // Draw each region's bounds.
            foreach (Region rgn in character_regions)
            {
                // Convert the region into a Rectangle.
                RectangleF character_bounds = rgn.GetBounds(gr);
                Rectangle character_rect = Rectangle.Round(character_bounds);

                // Draw the bounds.
                gr.FillRectangle(Brushes.Pink, character_rect);

                // Draw the top.
                using (Pen dashed_pen = new Pen(Color.Black))
                {
                    dashed_pen.DashStyle = DashStyle.Custom;
                    dashed_pen.DashPattern = new float[] { 3, 3 };
                    gr.DrawLine(dashed_pen,
                        character_rect.X - 20,
                        character_rect.Y,
                        character_rect.Right,
                        character_rect.Y);
                }

                // Draw the internal leading.
                gr.DrawLine(Pens.Red,
                    character_rect.X - 3,
                    character_rect.Y + font_info.RelTop,
                    character_rect.Right + 3,
                    character_rect.Y + font_info.RelTop);

                // Draw the ascent.
                gr.DrawLine(Pens.Green,
                    character_rect.X - 3,
                    character_rect.Y + font_info.RelBaseline,
                    character_rect.Right + 3,
                    character_rect.Y + font_info.RelBaseline);

                // Draw the descent.
                gr.DrawLine(Pens.Blue,
                    character_rect.X - 3,
                    character_rect.Y + font_info.RelBottom,
                    character_rect.Right + 3,
                    character_rect.Y + font_info.RelBottom);

                // Draw the next line.
                using (Pen dashed_pen = new Pen(Color.Blue))
                {
                    dashed_pen.DashStyle = DashStyle.Custom;
                    dashed_pen.DashPattern = new float[] { 1, 2, 3, 2 };
                    gr.DrawLine(dashed_pen,
                        character_rect.X,
                        character_rect.Y + font_info.LineSpacingPixels,
                        character_rect.Right + 30,
                        character_rect.Y + font_info.LineSpacingPixels);
                }

                // Fill the external leading.
                gr.FillRectangle(Brushes.Orange,
                    character_rect.X,
                    character_rect.Y + font_info.AscentPixels + font_info.DescentPixels,
                    character_rect.Width,
                    font_info.ExternalLeadingPixels);
            }

            // Draw the text.
            gr.DrawString(txt, the_font, Brushes.Black, layout_rect, string_format);
        }
    }
}
